#
# spec file for package libXpm
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           libXpm
%define lname	libXpm4
Version:        3.5.12
Release:        150000.3.10.1
Summary:        X Pixmap image file format library
License:        MIT
Group:          Development/Libraries/C and C++
Url:            http://xorg.freedesktop.org/

#Git-Clone:	git://anongit.freedesktop.org/xorg/lib/libXpm
#Git-Web:	http://cgit.freedesktop.org/xorg/lib/libXpm/
Source:         http://xorg.freedesktop.org/releases/individual/lib/%{name}-%{version}.tar.bz2
Source1:        baselibs.conf
Patch1207000:   U_0000-Update-README-for-gitlab-migration.patch
Patch1207001:   U_0001-configure-add-disable-open-zfile-instead-of-requirin.patch
Patch1207029:   U_0002-Fix-CVE-2022-46285-Infinite-loop-on-unclosed-comment.patch
Patch1207030:   U_0004-Fix-CVE-2022-44617-Runaway-loop-with-width-of-0-and-.patch
Patch1207031:   U_0005-Fix-CVE-2022-4883-compression-commands-depend-on-PAT.patch
Patch1207129:   U_regression-bug1207029_1207030_1207031.patch
Patch1207130:   U_regression2-bug1207029_1207030_1207031.patch
Patch1215690:   U_0000-test-Add-unit-tests-using-glib-framework.patch
Patch1215691:   U_0001-Fix-CVE-2023-43788-Out-of-bounds-read-in-XpmCreateXp.patch
Patch1215692:   U_0002-test-Add-test-case-for-CVE-2023-43789-corrupt-colorm.patch
Patch1215693:   U_0003-Fix-CVE-2023-43789-Out-of-bounds-read-on-XPM-with-co.patch
Patch1215694:   U_0004-test-Add-test-case-for-CVE-2023-43786-stack-exhausti.patch
Patch1215695:   U_0005-Avoid-CVE-2023-43786-stack-exhaustion-in-XPutImage.patch
Patch1215696:   U_0006-test-Add-test-case-for-CVE-2023-43787-integer-overfl.patch
Patch1215697:   U_0007-Avoid-CVE-2023-43787-integer-overflow-in-XCreateImag.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
#git#BuildRequires:	autoconf >= 2.60, automake, libtool
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gzip
BuildRequires:  libtool
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xextproto)
BuildRequires:  pkgconfig(xorg-macros) >= 1.8
BuildRequires:  pkgconfig(xproto) >= 7.0.17
BuildRequires:  pkgconfig(xt)

%description
libXpm facilitates working with XPM (X PixMap), a format for
storing/retrieving X pixmaps to/from files.

%package -n %lname
Summary:        X Pixmap image file format library
Group:          System/Libraries

%description -n %lname
libXpm facilitates working with XPM (X PixMap), a format for
storing/retrieving X pixmaps to/from files.

%package devel
Summary:        Development files for the X Pixmap image file format library
Group:          Development/Libraries/C and C++
Requires:       %lname = %version
# O/P added for 12.2
Provides:       xorg-x11-libXpm-devel = 7.6_%version-%release
Obsoletes:      xorg-x11-libXpm-devel < 7.6_%version-%release

%description devel
libXpm facilitates working with XPM (X PixMap), a format for
storing/retrieving X pixmaps to/from files.

This package contains the development headers for the library found
in %lname.

%package tools
Summary:        Conversion utilities for X Pixmap (XPM) files
Group:          Productivity/Graphics/Convertors
# O/P added for 12.2
Provides:       xorg-x11-libXpm = 7.6_%version-%release
Obsoletes:      xorg-x11-libXpm < 7.6_%version-%release

%description tools
The spxm tool converts XPM1/XPM2 files to XPM version 3.
The cxpm tool will check whether an XPM file is correct or not with
regard to its format.

%prep
%setup -q
%patch1207000 -p1
%patch1207001 -p1
%patch1207029 -p1
%patch1207030 -p1
%patch1207031 -p1
%patch1207129 -p1
%patch1207130 -p1
%patch1215690 -p1
%patch1215691 -p1
%patch1215692 -p1
%patch1215693 -p1
%patch1215694 -p1
%patch1215695 -p1
%patch1215696 -p1
%patch1215697 -p1

%build
autoreconf -fi
%configure --disable-static
make %{?_smp_mflags}

%install
make install DESTDIR="%buildroot"
rm -f "%buildroot/%_libdir"/*.la

%post -n %lname -p /sbin/ldconfig

%postun -n %lname -p /sbin/ldconfig

%files -n %lname
%defattr(-,root,root)
%_libdir/libXpm.so.4*

%files devel
%defattr(-,root,root)
%_includedir/X11/*
%_libdir/libXpm.so
%_libdir/pkgconfig/xpm.pc

%files tools
%defattr(-,root,root)
%_bindir/cxpm
%_bindir/sxpm
%_mandir/man1/cxpm.1*
%_mandir/man1/sxpm.1*

%changelog
* Wed Sep 27 2023 sndirsch@suse.com
- U_0000-test-Add-unit-tests-using-glib-framework.patch
  U_0001-Fix-CVE-2023-43788-Out-of-bounds-read-in-XpmCreateXp.patch
  U_0002-test-Add-test-case-for-CVE-2023-43789-corrupt-colorm.patch
  U_0003-Fix-CVE-2023-43789-Out-of-bounds-read-on-XPM-with-co.patch
  * fixes CVE-2023-43788 libXpm: out of bounds read in
    XpmCreateXpmImageFromBuffer() (boo#1215686)
  * fixes CVE-2023-43789 libXpm: out of bounds read on XPM with
    corrupted colormap (boo#1215687)
- U_0004-test-Add-test-case-for-CVE-2023-43786-stack-exhausti.patch
  U_0005-Avoid-CVE-2023-43786-stack-exhaustion-in-XPutImage.patch
  U_0006-test-Add-test-case-for-CVE-2023-43787-integer-overfl.patch
  U_0007-Avoid-CVE-2023-43787-integer-overflow-in-XCreateImag.patch
  * avoids to trigger CVE-2023-43786,CVE-2023-43787 (boo#1215684,
    boo#1215685); see changelog in libX11 update ...
* Tue Jan 17 2023 sndirsch@suse.com
- U_regression2-bug1207029_1207030_1207031.patch
  * second regression fix: Use gzip -d instead of gunzip
* Fri Jan 13 2023 sndirsch@suse.com
- U_regression-bug1207029_1207030_1207031.patch
  * regression fix for above patches
* Wed Jan 11 2023 sndirsch@suse.com
- U_0000-Update-README-for-gitlab-migration.patch
  * needed by U_0001-configure-add-disable-open-zfile-instead-of-requirin.patch
- U_0001-configure-add-disable-open-zfile-instead-of-requirin.patch
  * needed by U_0005-Fix-CVE-2022-4883-compression-commands-depend-on-PAT.patch
- U_0002-Fix-CVE-2022-46285-Infinite-loop-on-unclosed-comment.patch
  * libXpm: Infinite loop on unclosed comments (CVE-2022-46285,
    bsc#1207029)
- U_0004-Fix-CVE-2022-44617-Runaway-loop-with-width-of-0-and-.patch
  * libXpm: Runaway loop on width of 0 and enormous height
    (CVE-2022-44617, bsc#1207030)
- U_0005-Fix-CVE-2022-4883-compression-commands-depend-on-PAT.patch
  * libXpm: compression commands depend on $PATH (CVE-2022-4883,
    bsc#1207031)
* Sun Jan  1 2017 sndirsch@suse.com
- added baselibs.conf as source in specfile
* Sun Jan  1 2017 sndirsch@suse.com
- Update to version 3.5.12:
  * Fix abs() usage.
  * Fix out out boundary read on unknown colors
  * Gracefully handle EOF while parsing files.
  * Avoid OOB write when handling malicious XPM files.
  * Handle size_t in file/buffer length
* Thu Sep 12 2013 zaitor@opensuse.org
- Update to version 3.5.11:
  + Fix typo in COPYING (matches src/amigax.h).
  + Add noreturn attributes suggested by gcc.
  + Doclifter can't handle more than one dash in a name line.
  + Fix libXpm build with NO_ZPIPE.
  + Added 'const' attribute to all filename arguments in the API.
  + Added 'const' qualifier to the filename argument to internal
    functions.
  + Close fd if fdopen() or xpmPipeThrough() fails in
    OpenWriteFile().
  + autogen.sh: Implement GNOME Build API.
  + configure: Remove AM_MAINTAINER_MODE.
  + Define NO_ZPIPE when building for MinGW.
* Sun Feb 17 2013 jengelh@inai.de
- Use more robust make install call
* Wed Apr 11 2012 vuntz@opensuse.org
- Update to version 3.5.10:
  + Compiler warning fixes
  + Janitorial cleanups
  + Build configuration improvements
* Sun Feb 12 2012 jengelh@medozas.de
- Rename xorg-x11-libXpm to libXpm and utilize shlib policy
* Tue Dec 21 2010 sndirsch@novell.com
- bumped version number to 7.6
* Sat Oct 30 2010 sndirsch@novell.com
- libXpm 3.5.9
  * This minor maintenance release provides a large collection of
    build configuration improvements and other janitorial
    cleanups.
* Sun Apr  4 2010 sndirsch@suse.de
- libXpm 3.5.8
- bumped version number to 7.5
* Mon Dec 14 2009 jengelh@medozas.de
- add baselibs.conf as a source
* Sat May  2 2009 eich@suse.de
- revert static library and .la file removal
  for SUSE versions <= 11.1.
* Tue Apr 21 2009 crrodriguez@suse.de
- remove static libraries and "la" files
- run ldconfig in postun
* Thu Sep 11 2008 sndirsch@suse.de
- bumped release number to 7.4
* Thu Apr 10 2008 ro@suse.de
- added baselibs.conf file to build xxbit packages
  for multilib support
* Sat Sep 29 2007 sndirsch@suse.de
- bumped version to 7.3
* Fri Aug 24 2007 sndirsch@suse.de
- libXpm 3.5.7
  * Sun bug 4486226: Xpm is not internationalized
  * Use AM_CFLAGS & AM_CPPFLAGS to replace per-program and obsolete macros
  * Include comment/copyright/license for AC_DEFINE_DIR in acinclude.m4
  * Replace index/rindex with C89 standard strchr/strrchr
  * Use srcdir in paths passed to xgettext when making .po files
  * Replace strcpy with strncpy to match previous code block
  * X.Org Bug #11863: Build libXpm on MS Windows (with MinGW)
* Sat Oct 14 2006 sndirsch@suse.de
- updated to X.Org 7.2RC1
* Wed Aug  2 2006 sndirsch@suse.de
- fix setup line
* Fri Jul 28 2006 sndirsch@suse.de
- use "-fno-strict-aliasing"
* Thu Jul 27 2006 sndirsch@suse.de
- use $RPM_OPT_FLAGS
- remove existing /usr/include/X11 symlink in %%pre
* Fri Jun 23 2006 sndirsch@suse.de
- created package
